<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<!-- Additional documentation for the optim package for Octave.

Copyright (C) Olaf Till <i7tiol@t-online.de>

You can redistribute this documentation and/or modify it under the terms
of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any
later version.

This documentation is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along
with this documentation; if not, see <http://www.gnu.org/licenses/>. -->
<!-- Created by GNU Texinfo 6.3, http://www.gnu.org/software/texinfo/ -->
<head>
<title>optim_doc: nlinfit</title>

<meta name="description" content="optim_doc: nlinfit">
<meta name="keywords" content="optim_doc: nlinfit">
<meta name="resource-type" content="document">
<meta name="distribution" content="global">
<meta name="Generator" content="makeinfo">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="index.html#Top" rel="start" title="Top">
<link href="Function-index.html#Function-index" rel="index" title="Function index">
<link href="Compatibility-functions.html#Compatibility-functions" rel="up" title="Compatibility functions">
<link href="fmincon.html#fmincon" rel="next" title="fmincon">
<link href="lsqcurvefit.html#lsqcurvefit" rel="prev" title="lsqcurvefit">
<style type="text/css">
<!--
a.summary-letter {text-decoration: none}
blockquote.indentedblock {margin-right: 0em}
blockquote.smallindentedblock {margin-right: 0em; font-size: smaller}
blockquote.smallquotation {font-size: smaller}
div.display {margin-left: 3.2em}
div.example {margin-left: 3.2em}
div.lisp {margin-left: 3.2em}
div.smalldisplay {margin-left: 3.2em}
div.smallexample {margin-left: 3.2em}
div.smalllisp {margin-left: 3.2em}
kbd {font-style: oblique}
pre.display {font-family: inherit}
pre.format {font-family: inherit}
pre.menu-comment {font-family: serif}
pre.menu-preformatted {font-family: serif}
pre.smalldisplay {font-family: inherit; font-size: smaller}
pre.smallexample {font-size: smaller}
pre.smallformat {font-family: inherit; font-size: smaller}
pre.smalllisp {font-size: smaller}
span.nolinebreak {white-space: nowrap}
span.roman {font-family: initial; font-weight: normal}
span.sansserif {font-family: sans-serif; font-weight: normal}
ul.no-bullet {list-style: none}
-->
</style>


</head>

<body lang="en">
<a name="nlinfit"></a>
<div class="header">
<p>
Next: <a href="fmincon.html#fmincon" accesskey="n" rel="next">fmincon</a>, Previous: <a href="lsqcurvefit.html#lsqcurvefit" accesskey="p" rel="prev">lsqcurvefit</a>, Up: <a href="Compatibility-functions.html#Compatibility-functions" accesskey="u" rel="up">Compatibility functions</a> &nbsp; [<a href="Function-index.html#Function-index" title="Index" rel="index">Index</a>]</p>
</div>
<hr>
<a name="Non_002dlinear-regression"></a>
<h3 class="section">7.5 Non-linear regression</h3>
<a name="index-nlinfit-4"></a>

<p>This function is for Matlab compatibility. It attempts to work like
<code>nlinfit</code> by calling <a href="nonlin_005fcurvefit.html#nonlin_005fcurvefit">nonlin_curvefit</a> and <a href="curvefit_005fstat.html#curvefit_005fstat">curvefit_stat</a>.
</p>
<a name="XREFnlinfit"></a><dl>
<dt><a name="index-nlinfit"></a>Function File: <em></em> <strong>nlinfit</strong> <em>(<var>X</var>, <var>Y</var>, <var>modelfun</var>, <var>beta0</var>)</em></dt>
<dt><a name="index-nlinfit-1"></a>Function File: <em></em> <strong>nlinfit</strong> <em>(<var>X</var>, <var>Y</var>, <var>modelfun</var>, <var>beta0</var>, <var>options</var>)</em></dt>
<dt><a name="index-nlinfit-2"></a>Function File: <em></em> <strong>nlinfit</strong> <em>(&hellip;, <var>Name</var>, <var>Value</var>)</em></dt>
<dt><a name="index-nlinfit-3"></a>Function File: <em>[<var>beta</var>, <var>R</var>, <var>J</var>, <var>CovB</var>, <var>MSE</var>] =</em> <strong>nlinfit</strong> <em>(&hellip;)</em></dt>
<dd><p>Nonlinear Regression.
</p>
<div class="example">
<pre class="example">min [EuclidianNorm (Y - modelfun (beta, X))] ^ 2
beta
</pre></div>

<p><var>X</var> is a matrix of independents, <var>Y</var> is the observed output and <var>modelfun</var> is the nonlinear regression model function.
<var>modelfun</var> should be specified as a function handle, which
accepts two inputs: an array of coefficients and an array of
independents &ndash; in that order.
The first four input arguments must be provided with non-empty initial guess of the coefficients <var>beta0</var>.
<var>Y</var> and <var>X</var> must be the same size as the vector (or matrix) returned by <var>fun</var>.
<var>options</var> is a structure containing estimation algorithm options. It can be set using <code>statset</code>.
Follwing Matlab compatible options are recognized:
</p>
<p><code>TolFun</code>
   Minimum fractional improvement in objective function in an iteration
   (termination criterium). Default: 1e-6.
</p>
<p><code>MaxIter</code>
   Maximum number of iterations allowed. Default: 400.
</p>
<p><code>DerivStep</code>
   Step size factor. The default is eps^(1/3) for finite differences gradient
   calculation.
</p>
<p><code>Display</code>
   String indicating the degree of verbosity. Default: &quot;off&quot;.
   Currently only supported values are &quot;off&quot; (no messages) and &quot;iter&quot;
   (some messages after each iteration).
</p>
<p>Optional <var>Name</var>, <var>Value</var> pairs can be provided to set additional options.
Currently the only applicable name-value pair is &rsquo;Weights&rsquo;, w,
where w is the array of real positive weight factors for the
squared residuals.
</p>
<p>Returned values:
</p>
<dl compact="compact">
<dt><var>beta</var></dt>
<dd><p>Coefficients to best fit the nonlinear function modelfun (beta, X) to the observed values Y.
</p>
</dd>
<dt><var>R</var></dt>
<dd><p>Value of solution residuals: <code>modelfun (beta, X) - Y</code>.
If observation weights are specified then <var>R</var> is the array of
weighted residuals: <code>sqrt (weights) .* modelfun (beta, X) - Y</code>.
</p>
</dd>
<dt><var>J</var></dt>
<dd><p>A matrix where <code>J(i,j)</code> is the partial derivative of <code>modelfun(i)</code> with respect to <code>beta(j)</code>.
If observation weights are specified, then <var>J</var> is the weighted
model function Jacobian: <code>diag (sqrt (weights)) * J</code>.
</p>
</dd>
<dt><var>CovB</var></dt>
<dd>
<p>Estimated covariance matrix of the fitted coefficients.
</p>
</dd>
<dt><var>MSE</var></dt>
<dd><p>Scalar valued estimate of the variance of error term. If the model Jacobian is full rank, then MSE = (R&rsquo; * R)/(N-p),
where N is the number of observations and p is the number of estimated coefficients.
</p></dd>
</dl>

<p>This function is a compatibility wrapper. It calls the more general <code>nonlin_curvefit</code>
and <code>curvefit_stat</code> functions internally.
</p>

<p><strong>See also:</strong> <a href="nonlin_005fresidmin.html#XREFnonlin_005fresidmin">nonlin_residmin</a>, <a href="nonlin_005fcurvefit.html#XREFnonlin_005fcurvefit">nonlin_curvefit</a>, <a href="residmin_005fstat.html#XREFresidmin_005fstat">residmin_stat</a>, <a href="curvefit_005fstat.html#XREFcurvefit_005fstat">curvefit_stat</a>.
</p></dd></dl>



<hr>
<div class="header">
<p>
Next: <a href="fmincon.html#fmincon" accesskey="n" rel="next">fmincon</a>, Previous: <a href="lsqcurvefit.html#lsqcurvefit" accesskey="p" rel="prev">lsqcurvefit</a>, Up: <a href="Compatibility-functions.html#Compatibility-functions" accesskey="u" rel="up">Compatibility functions</a> &nbsp; [<a href="Function-index.html#Function-index" title="Index" rel="index">Index</a>]</p>
</div>



</body>
</html>
